---
title: FormData
slug: Web/API/FormData
tags:
  - API
  - FormData
  - Interface
  - Reference
  - XMLHttpRequest
---
<p>{{APIRef("XMLHttpRequest")}}</p>

<p>The <strong><code>FormData</code></strong> interface provides a way to easily construct a set of key/value pairs representing form fields and their values, which can then be easily sent using the {{domxref("XMLHttpRequest.send()")}} method. It uses the same format a form would use if the encoding type were set to <code>"multipart/form-data"</code>.</p>

<p>You can also pass it directly to the {{domxref("URLSearchParams")}} constructor if you want to generate query parameters in the way a {{HTMLElement("form")}} would do if it were using simple <code>GET</code> submission.</p>

<p>An object implementing <code>FormData</code> can directly be used in a {{jsxref("Statements/for...of", "for...of")}} structure, instead of {{domxref('FormData.entries()', 'entries()')}}: <code>for (var p of myFormData)</code> is equivalent to <code>for (var p of myFormData.entries())</code>.</p>

<div class="note">
<p><strong>Note</strong>: This feature is available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a>.</p>
</div>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("FormData.FormData","FormData()")}}</dt>
 <dd>Creates a new <code>FormData</code> object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("FormData.append()")}}</dt>
 <dd>Appends a new value onto an existing key inside a <code>FormData</code> object, or adds the key if it does not already exist.</dd>
 <dt>{{domxref("FormData.delete()")}}</dt>
 <dd>Deletes a key/value pair from a <code>FormData</code> object.</dd>
 <dt>{{domxref("FormData.entries()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols","iterator")}} allowing to go through all key/value pairs contained in this object.</dd>
 <dt>{{domxref("FormData.get()")}}</dt>
 <dd>Returns the first value associated with a given key from within a <code>FormData</code> object.</dd>
 <dt>{{domxref("FormData.getAll()")}}</dt>
 <dd>Returns an array of all the values associated with a given key from within a <code>FormData</code>.</dd>
 <dt>{{domxref("FormData.has()")}}</dt>
 <dd>Returns a boolean stating whether a <code>FormData</code> object contains a certain key.</dd>
 <dt>{{domxref("FormData.keys()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}} allowing to go through all keys of the key/value pairs contained in this object.</dd>
 <dt>{{domxref("FormData.set()")}}</dt>
 <dd>Sets a new value for an existing key inside a <code>FormData</code> object, or adds the key/value if it does not already exist.</dd>
 <dt>{{domxref("FormData.values()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}} allowing to go through all values  contained in this object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest','#interface-formdata','FormData')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>FormData defined in XHR spec</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FormData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("XMLHTTPRequest")}}</li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/FormData/Using_FormData_Objects">Using FormData objects</a></li>
 <li>{{HTMLElement("Form")}}</li>
</ul>
